/*
 * Created by JFormDesigner on Wed May 14 08:53:34 CST 2025
 */

package cn.vscoder.experiment_5.BookSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.*;

/**
 * @author xulongjin
 */
public class BookManagerSystem extends JFrame {
    public BookManagerSystem() {
        initComponents();
    }

    private void createBook(ActionEvent e) {
        // TODO add your code here
        dModel = (DefaultTableModel) tableBookList.getModel();

        Vector data = new Vector<>();
        data.addElement(inputBookSN.getText());
        data.addElement(inputBookName.getText());
        data.addElement(inputBookAuthor.getText());
        data.addElement(inputBookPublisher.getText());
        data.addElement(inputBookPrice.getText());
        data.addElement(inputBookRegisNumber.getText());
        data.addElement(selectIsBorrow.isSelected());

        dModel.addRow(data);

        inputBookSN.setText("");
        inputBookName.setText("");
        inputBookAuthor.setText("");
        inputBookPublisher.setText("");
        inputBookPrice.setText("");
        inputBookRegisNumber.setText("");
        selectIsBorrow.setSelected(false);

    }

    private void changeInfo(ActionEvent e) {
        // TODO add your code here
        int i = tableBookList.getSelectedRow();
        if (i > -1) {
            DefaultTableModel dModel = (DefaultTableModel) tableBookList.getModel();
            dModel.setValueAt(inputBookSN.getText(), i, 0);
            dModel.setValueAt(inputBookName.getText(), i, 1);
            dModel.setValueAt(inputBookAuthor.getText(), i, 2);
            dModel.setValueAt(inputBookPublisher.getText(), i, 3);
            dModel.setValueAt(inputBookPrice.getText(), i, 4);
            dModel.setValueAt(inputBookRegisNumber.getText(), i, 5);
            dModel.setValueAt(selectIsBorrow.isSelected(), i, 6);

            inputBookSN.setText("");
            inputBookName.setText("");
            inputBookAuthor.setText("");
            inputBookPublisher.setText("");
            inputBookPrice.setText("");
            inputBookRegisNumber.setText("");
            selectIsBorrow.setSelected(false);

        } else {
            JOptionPane.showMessageDialog(this, "请先选择要修改的图书！");
        }
    }

    private void deleteBook(ActionEvent e) {
        // TODO add your code here
        DefaultTableModel dModel = (DefaultTableModel) tableBookList.getModel();
        int i = tableBookList.getSelectedRow();
        if (i > -1) {
            dModel.removeRow(i);
        } else {
            JOptionPane.showMessageDialog(this, "请先选择要删除的图书！");
        }
    }

    private void initComponents() {
        // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents  @formatter:off
        panel1 = new JPanel();
        textBookSN = new JLabel();
        textBookName = new JLabel();
        textBookRegisNumber = new JLabel();
        textBookPrice = new JLabel();
        textBookPublisher = new JLabel();
        textBookAuthor = new JLabel();
        inputBookSN = new JTextField();
        inputBookName = new JTextField();
        inputBookRegisNumber = new JTextField();
        inputBookPrice = new JTextField();
        inputBookPublisher = new JTextField();
        inputBookAuthor = new JTextField();
        panel2 = new JPanel();
        buttonCreateBook = new JButton();
        buttonChangeInfo = new JButton();
        buttonDeleteBook = new JButton();
        selectIsBorrow = new JCheckBox();
        scrollPane1 = new JScrollPane();
        tableBookList = new JTable();

        //======== this ========
        setTitle("\u56fe\u4e66\u7ba1\u7406\u7cfb\u7edf");
        setMaximumSize(new Dimension(2147483647, 600));
        var contentPane = getContentPane();
        contentPane.setLayout(new GridLayout(3, 0));

        //======== panel1 ========
        {
            panel1.setLayout(null);

            //---- textBookSN ----
            textBookSN.setText("\u56fe\u4e66\u7f16\u53f7\uff1a");
            panel1.add(textBookSN);
            textBookSN.setBounds(40, 20, 75, 30);

            //---- textBookName ----
            textBookName.setText("\u56fe\u4e66\u540d\u79f0\uff1a");
            panel1.add(textBookName);
            textBookName.setBounds(40, 65, 75, 30);

            //---- textBookRegisNumber ----
            textBookRegisNumber.setText("\u56fe\u4e66\u5165\u5e93\u53f7\uff1a");
            panel1.add(textBookRegisNumber);
            textBookRegisNumber.setBounds(40, 110, 90, 30);

            //---- textBookPrice ----
            textBookPrice.setText("\u5b9a    \u4ef7\uff1a");
            panel1.add(textBookPrice);
            textBookPrice.setBounds(320, 20, 75, 30);

            //---- textBookPublisher ----
            textBookPublisher.setText("\u51fa\u7248\u793e  \uff1a");
            panel1.add(textBookPublisher);
            textBookPublisher.setBounds(320, 65, 75, 30);

            //---- textBookAuthor ----
            textBookAuthor.setText("\u56fe\u4e66\u4f5c\u8005\uff1a");
            panel1.add(textBookAuthor);
            textBookAuthor.setBounds(320, 110, 75, 30);
            panel1.add(inputBookSN);
            inputBookSN.setBounds(115, 15, 180, 39);
            panel1.add(inputBookName);
            inputBookName.setBounds(115, 60, 180, 39);
            panel1.add(inputBookRegisNumber);
            inputBookRegisNumber.setBounds(115, 105, 180, 39);
            panel1.add(inputBookPrice);
            inputBookPrice.setBounds(385, 15, 180, 39);
            panel1.add(inputBookPublisher);
            inputBookPublisher.setBounds(385, 60, 180, 39);
            panel1.add(inputBookAuthor);
            inputBookAuthor.setBounds(385, 105, 180, 39);

            {
                // compute preferred size
                Dimension preferredSize = new Dimension();
                for(int i = 0; i < panel1.getComponentCount(); i++) {
                    Rectangle bounds = panel1.getComponent(i).getBounds();
                    preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width);
                    preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
                }
                Insets insets = panel1.getInsets();
                preferredSize.width += insets.right;
                preferredSize.height += insets.bottom;
                panel1.setMinimumSize(preferredSize);
                panel1.setPreferredSize(preferredSize);
            }
        }
        contentPane.add(panel1);

        //======== panel2 ========
        {
            panel2.setLayout(null);

            //---- buttonCreateBook ----
            buttonCreateBook.setText("\u521b\u5efa\u56fe\u4e66");
            buttonCreateBook.addActionListener(e -> createBook(e));
            panel2.add(buttonCreateBook);
            buttonCreateBook.setBounds(45, 55, 110, 50);

            //---- buttonChangeInfo ----
            buttonChangeInfo.setText("\u66f4\u6b63\u4fe1\u606f");
            buttonChangeInfo.addActionListener(e -> changeInfo(e));
            panel2.add(buttonChangeInfo);
            buttonChangeInfo.setBounds(230, 55, 110, 50);

            //---- buttonDeleteBook ----
            buttonDeleteBook.setText("\u5220\u9664\u56fe\u4e66");
            buttonDeleteBook.addActionListener(e -> deleteBook(e));
            panel2.add(buttonDeleteBook);
            buttonDeleteBook.setBounds(420, 55, 110, 50);

            //---- selectIsBorrow ----
            selectIsBorrow.setText("\u662f\u5426\u53ef\u501f");
            panel2.add(selectIsBorrow);
            selectIsBorrow.setBounds(390, 10, 115, 35);

            {
                // compute preferred size
                Dimension preferredSize = new Dimension();
                for(int i = 0; i < panel2.getComponentCount(); i++) {
                    Rectangle bounds = panel2.getComponent(i).getBounds();
                    preferredSize.width = Math.max(bounds.x + bounds.width, preferredSize.width);
                    preferredSize.height = Math.max(bounds.y + bounds.height, preferredSize.height);
                }
                Insets insets = panel2.getInsets();
                preferredSize.width += insets.right;
                preferredSize.height += insets.bottom;
                panel2.setMinimumSize(preferredSize);
                panel2.setPreferredSize(preferredSize);
            }
        }
        contentPane.add(panel2);

        //======== scrollPane1 ========
        {

            //---- tableBookList ----
            tableBookList.setModel(new DefaultTableModel(
                new Object[][] {
                },
                new String[] {
                    "ISBN", "\u4e66\u540d", " \u4f5c\u8005", " \u51fa\u7248\u793e", " \u5b9a\u4ef7", "\u5165\u5e93\u53f7", "\u662f\u5426\u53ef\u501f"
                }
            ));
            scrollPane1.setViewportView(tableBookList);
        }
        contentPane.add(scrollPane1);
        pack();
        setLocationRelativeTo(getOwner());
        // JFormDesigner - End of component initialization  //GEN-END:initComponents  @formatter:on

        tableBookList.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                i = tableBookList.getSelectedRow();
                if (i >= 0) {
                    inputBookSN.setText(dModel.getValueAt(i, 0).toString());
                    inputBookName.setText(dModel.getValueAt(i, 1).toString());
                    inputBookAuthor.setText(dModel.getValueAt(i, 2).toString());
                    inputBookPublisher.setText(dModel.getValueAt(i, 3).toString());
                    inputBookPrice.setText(dModel.getValueAt(i, 4).toString());
                    inputBookRegisNumber.setText(dModel.getValueAt(i, 5).toString());
                    selectIsBorrow.setSelected(Boolean.parseBoolean(dModel.getValueAt(i, 6).toString()));
                }
            }
        });

    }

    // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables  @formatter:off
    private JPanel panel1;
    private JLabel textBookSN;
    private JLabel textBookName;
    private JLabel textBookRegisNumber;
    private JLabel textBookPrice;
    private JLabel textBookPublisher;
    private JLabel textBookAuthor;
    private JTextField inputBookSN;
    private JTextField inputBookName;
    private JTextField inputBookRegisNumber;
    private JTextField inputBookPrice;
    private JTextField inputBookPublisher;
    private JTextField inputBookAuthor;
    private JPanel panel2;
    private JButton buttonCreateBook;
    private JButton buttonChangeInfo;
    private JButton buttonDeleteBook;
    private JCheckBox selectIsBorrow;
    private JScrollPane scrollPane1;
    private JTable tableBookList;
    // JFormDesigner - End of variables declaration  //GEN-END:variables  @formatter:on

    DefaultTableModel dModel;
    int i;

}
